#include <vector>
#include "TClass.h"
#include "TTree.h"
#include "TObject.h"
#include "TArrayF.h"

class MyClass : public TObject
{
private:
    unsigned short mySimpleMember;
    std::vector<unsigned short> myVectMember;

public:
    MyClass();

    ~MyClass();

    void Clear();

    inline std::vector<unsigned short> GetVectorMember() const
    {
        return myVectMember;
    }

    inline TArrayF* DumpVectorToArray() const
    {
        TArrayF* dump = new TArrayF ( myVectMember.size() );

        for ( unsigned short i = 0; i < myVectMember.size(); i++ )
        {
            dump->SetAt ( myVectMember[i], i );
        }

        return dump;
    }

    inline unsigned short GetSimpleMember() const
    {
        return mySimpleMember;
    }

    void SetSimpleMember ( unsigned short val );
    void AddValToVect ( unsigned short val );

    ClassDef ( MyClass, 1 )
};


class MyVectorsContainer
{
private:

public:
    MyVectorsContainer() {}

    ~MyVectorsContainer() {}

    std::vector<float> myVect1;
    std::vector<float> myVect2;

    inline void Clear()
    {
        myVect1.clear();
        myVect2.clear();
    }

    ClassDef ( MyVectorsContainer, 1 )
};

ClassImp ( MyVectorsContainer )


class MyMainContainer
{
private:

public:
    MyMainContainer() {}

    ~MyMainContainer() {}

    MyVectorsContainer myCont1;
    MyVectorsContainer myCont2;
    MyVectorsContainer myCont3;

    inline void Clear()
    {
        myCont1.Clear();
        myCont2.Clear();
        myCont3.Clear();
    }

    ClassDef ( MyMainContainer, 1 )
};

ClassImp ( MyMainContainer )

class MyBaseClass
{
private:

public:
    MyBaseClass() {}

    ~MyBaseClass() {}

    MyMainContainer myCont;

    inline void Clear()
    {
        myCont.Clear();
    }

    ClassDef ( MyBaseClass, 1 )
};

ClassImp ( MyBaseClass )
